;Passport Updater for Vincula Users
;By The Gate Keeper
;Special thanks to JD and xnextx - for their quick code generations
;And for clearing up things with ssl sockets.
;=================================================================================

;the brackets [ ] means that the field is optional.
;/update [passport] : Updates passport - Cookies Only. If Passport is specified, it updates that, otherwise updates the default passport.
;/update -s [passport] : Updates Passport - Cookies + RegCookie + SubscriberInfo.
;/update -u [<passport> <group>] : Updates Passport - RegCookie + Userrole for given group. If not given, it will ask you for your group name.
alias update {
  var %msg = echo $color(info2) -at e $+ $color(kick) Error: $+ $color(info2)
  if ($findtok(-n -s -u,$1,1,32)) { var %u = $1 | tokenize 32 $2- }
  else { var %u = -n | tokenize 32 $1- }
  if ($vincdir) var %dir = $mircdir $+ $vincdir $+ vpassport.dat
  else { %msg Vincula file not found. Please ensure you have a vincula.mrc located within your mIRC directory. | return }
  var %pp = $iif($1,$1,$msn.ini(selpp)) , %e = $readini(%dir,%pp,email) , %p = $readini(%dir,%pp,passwd) , %h
  if (!%e) { %e = $$?="Please enter an email to use for the updater" | writeini $+(",%dir,") %pp email %e }
  if (!%p) { %e = $$?="Please enter password for %e $+ " | writeini $+(",%dir,") %pp passwd %p }
  if (%u == -u) {
    set -e %ppu.group $iif($2,$2,$$?="Please enter the Group name here:")
    if (http://groups.msn.com/* iswm %ppu.group) %ppu.group = $gettok(%ppu.group,3,47)
    elseif (?#G_* iswm %ppu.group) %ppu.group = $right(%ppu.group,-4)
    elseif (#G_* iswm %ppu.group) %ppu.group = $right(%ppu.group,-3)
    elseif (G_* iswm %ppu.group) %ppu.group = $right(%ppu.group,-2)
    %ppu.group = $remove(%ppu.group,$chr(32))
  }
  %h = $iif(*@hotmail.* iswm %e,loginnet,$iif(*@msn.* iswm %e,msnialogin,login)) $+ .passport.com
  var %m = echo $color(info) -at 5 Updating the " $+ %pp $+ " passport (Cookies
  if (%u == -n) %m only), please wait...
  elseif (%u == -s) %m + SubscriberInfo), please wait...
  else %m + UserRole for group " $+ %ppu.group $+ "), please wait...
  set -e %ppu.ticks $ticks
  if ($os isin XP 2K 2003) {
    var %a = Passport1.4 OrgVerb=GET,OrgURL=?,sign-in= $+ $ppu.urlencode(%e) $+ ,pwd= $+ $ppu.urlencode(%p) $+ ,id=507
    set -e %ppu.pend ppu.start. $+ %pp %h %u %e %p
    if ($com(auth)) { .comclose auth } 
    .comopen auth WinHttp.WinHttpRequest.5.1 
    if ($comerr) { 
      .comreg winhttp5.1.dll 
      .comopen auth WinHttp.WinHttpRequest.5.1 
      if ($comerr) goto :nhtml
    } 
    if (!$com(auth,Open,1,bstr,GET,bstr,https:// $+ %h $+ /login2.srf)) { return } 
    if (!$com(auth,SetRequestHeader,1,bstr,Authorization,bstr,%a)) { return } 
    if (!$com(auth,SetRequestHeader,1,bstr,Host,bstr,%h)) { return } 
    if (!$com(auth,Send,1)) { return } 
    if ($com(auth,GetResponseHeader,1,bstr,authentication-info)) { ppu.handle $com(auth).result }
  }
  elseif ($sslready) && ($version >= 6.17) { sockclose ppu.start. $+ %pp | sockopen -e ppu.start. $+ %pp %h 443 | sockmark ppu.start. $+ %pp %h %u %e %p }
  else {
    :nhtml | var %f = $findfile($mircdir,nhtmln*.dll,1)
    if (!%f) { %msg Due to you being on a version prior to mIRC 6.17, this updater requires that you have an nhtmln_2.9x.dll located in your mIRC directory. This file was not found. Please place one within mIRC's directory to use this updater. | return }
    window -p @update
    dll $+(",%f,") attach $window(@update).hwnd
    dll $+(",%f,") handler ppu.handle
    dll $+(",%f,") navigate http://login.passport.com/logout.srf?lc=1033&id=2260&ru=http%3A%2F%2Fwww%2Emsn%2Ecom%2F
    set -e %ppu.pend ppu.start. $+ %pp %h %u %e %p
  }
}
alias vincdir { var %l = 1 | while ($script(%l)) { var %i = $ifmatch | if (*vinc*.mrc iswm %i) && (%i != $script) { return $remove(%i,$mircdir,$gettok(%i,-1,92)) | break } | inc %l } }
alias ppu.sivar return $iif($var(%msnpp.SubscriberInfo),SubScriberInfo,subinfo)
;Alias by JD - from SSL Passport Updater
alias ppu.urlencode {
  var %encode = $1-
  while ($regex($eval(%encode,1), /([^a-zA-Z0-9_\-\.])/)) {
    var %t = $regsub($eval(%encode,1), /([^a-zA-Z0-9_\-\.])/, $+(,$base($asc($regml(1)),10,16,2)), %encode)
  }
  return $replace(%encode, , %)
}
alias ppu.handle {
  if (*navigate_complete http://www.msn.com/* iswm $1-) {
    var %f = $findfile($mircdir,nhtmln*.dll,1)
    echo $color(info2) -at 3 Redirecting you to login to MSN.... Please login when you reached the login screen.
    dll $+(",%f,") navigate http://login.passport.net/uilogin.srf?lc=1033&id=2260
  }
  if ($regex($1-,/'t=(.+)&p=(.+)'.+/)) {
    ;echo -at : $1-
    .timerclose 1 0 window -c @update
    tokenize 32 %ppu.pend | var %s = $1 , %m = $2- , %m2 = $gettok(%m,2,32) , %p = $gettok(%s,3-,46) , %dir = $mircdir $+ $vincdir $+ vpassport.dat
    writeini $+(",%dir,") %p ticket $regml(1)
    writeini $+(",%dir,") %p profile $regml(2)
    writeini $+(",%dir,") %p updated $ctime
    if (%p == $msn.ini(selpp)) { %msnpp.ticket = $readini(%dir,%p,ticket) | %msnpp.profile = $readini(%dir,%p,profile) }
    if (-u == %m2) && (%ppu.group) { var %u = $replace(%s,start,userrole. $+ %ppu.group) | sockclose %u | sockopen %u groups.msn.com 80 | sockmark %u %m }
    elseif (-s == %m2) { var %u = $replace(%s,start,regcookie) | sockclose %u | sockopen %u chat.msn.com 80 | sockmark %u %m }
    else { echo $color(info2) -at 3 Passport info (Cookies only) for " $+ %p $+ " is now updated ( $+ $calc(($ticks - %ppu.ticks) / 1000) seconds) | sockclose %s | unset %ppu.* | return }
  }
  return S_OK
}
on *:SOCKOPEN:ppu.*: {
  var %s = $sockname , %m = $sock(%s).mark , %ip = $sock(%s).ip , %port = $sock(%s).port , %t = $gettok(%s,2,46) , %msg , %p = $iif(%t == userrole,$gettok(%s,4-,46),$gettok(%s,3-,46)) , %dir = $mircdir $+ $vincdir $+ vpassport.dat , %pp = $readini(%dir,%p,profile) , %pt = $readini(%dir,%p,ticket) , %o = 9,02,0310,2401
  if ($sockerr > 0) { sockclose %s | sockopen %s %ip %port | sockmark %s %m | return } 
  if (%t == start) {
    tokenize 32 %m
    var %a = Passport1.4 OrgVerb=GET,OrgURL=?,sign-in= $+ $ppu.urlencode($3) $+ ,pwd= $+ $ppu.urlencode($4) $+ ,id=507
    .timer $+ %s -m 1 1 sockwrite -n %s $+(GET /login2.srf HTTP/1.1,$crlf,Authorization: %a,$crlf,Host: $1,$crlf,$crlf)
  }
  if (%t == regcookie) sockwrite -n %s $+(GET /chatroom.msnw?rm=TheLobby HTTP/1.1,$crlf,User-Agent: VincUpdater (compatible; MSIE 6.0; Windows NT 5.1),$crlf,Accept: */*,$crlf,Accept-Language: EN-US,$crlf,Host: chat.msn.com,$crlf,Cookie: path=/;hasOCX=,%o,; MSPProf=,%pp,; MSPAuth=,%pt,;,$crlf,Connection: Close,$crlf,$crlf)
  elseif (%t == subinfo) sockwrite -n %s $+(GET /RenderChat.msnw? HTTP/1.1,$crlf,User-Agent: VincUpdater (compatible; MSIE 6.0; Windows NT 5.1),$crlf,Host: chat.msn.com,$crlf,Connection: Keep-Alive,$crlf,Cookie: MSPProf=,%pp,; MSPAuth=,%pt,;,$crlf,$crlf)
  elseif (%t == userrole) sockwrite -n %s $+(GET /,$gettok(%s,3,46),/chat.msnw HTTP/1.1,$crlf,User-Agent: VincUpdater (compatible; MSIE 6.0; Windows NT 5.1),$crlf,Host: groups.msn.com,$crlf,Cookie: AdultWarn=1;path=/;chocx=,%o,; MSPProf=,%pp,; MSPAuth=,%pt,;,$crlf,Connection: Close,$crlf,$crlf)
}
on *:SOCKREAD:ppu.*: {
  var %s = $sockname , %m = $sock(%s).mark , %m2 = $gettok(%m,2,32) , %t = $gettok(%s,2,46) , %msg , %p = $iif(%t == userrole,$gettok(%s,4-,46),$gettok(%s,3-,46)) , %i , %dir = $mircdir $+ $vincdir $+ vpassport.dat
  if ($sockerr > 0) { return }
  if (ppu.userrole.* !iswm %s) sockread -n &ppu
  else { sockread %i | if ($remove(%i,$chr(32))) && ($len(%i) < 900) { bset -t &ppu 1 %i } }
  if ($bvar(&ppu,0) > 0) {
    if (%t == start) {
      if ($bfind(&ppu,1-,WWW-Authenticate:)) && (($bfind(&ppu,1-,da-status=failed)) || ($bfind(&ppu,1-,Unauthorized))) { echo $color(info2) -at 4 $+ $color(kick) Error: $+ $color(info2) The passport " $+ %p $+ " could not be updated because your email and/or password is incorrect. | sockclose %s | return }
      elseif ($bfind(&ppu,1-,Authentication-Info:)) { 
        writeini $+(",%dir,") %p ticket $remove($gettok($wildtok($bvar(&ppu,1-).text,*t=*,1,44),3,61),&p)) 
        writeini $+(",%dir,") %p profile $gettok($wildtok($bvar(&ppu,1-).text,*p=*,2,39),3,61)) 
        writeini $+(",%dir,") %p updated $ctime
        if (%p == $msn.ini(selpp)) { %msnpp.ticket = $readini(%dir,%p,ticket) | %msnpp.profile = $readini(%dir,%p,profile) }
        if (-u == %m2) && (%ppu.group) { var %u = $replace(%s,start,userrole. $+ %ppu.group) | sockclose %u | sockopen %u groups.msn.com 80 | sockmark %u %m }
        elseif (-s == %m2) { var %u = $replace(%s,start,regcookie) | sockclose %u | sockopen %u chat.msn.com 80 | sockmark %u %m }
        else { echo $color(info2) -at 3 Passport info (Cookies only) for " $+ %p $+ " is now updated ( $+ $calc(($ticks - %ppu.ticks) / 1000) seconds) | sockclose %s | unset %ppu.* | return }
      }
      elseif ($bfind(&ppu,1-,Location:)) { sockclose %s | sockopen -e %s $gettok($bvar(&ppu,11-).text,2,47) 443 }
    }
    if (%t == regcookie) {
      if ($bfind(&ppu,1-,Set-Cookie: MSNChatNN=)) { writeini $+(",%dir,") %p cookie $gettok($gettok($bvar(&ppu,1-).text,2,61),1,59) | if (%p == $msn.ini(selpp)) { %msnpp.cookie = $readini(%dir,%p,cookie) } | sockclose $replace(%s,regcookie,subinfo) | sockopen $replace(%s,regcookie,subinfo) chat.msn.com 80 }
      elseif ($bfind(&ppu,1-,Location: /KidsPassport.msnw)) || ($bfind(&ppu,1-,Location: /mdunavail.msnw)) || ($bfind(&ppu,1-,temp += '</OBJECT>';)) {
        remini $+(",%dir,") %p cookie | remini $+(",%dir,") %p $ppu.sivar
        echo $color(info2) -at 3 Passport info (Cookies) for " $+ %p $+ " is now updated ( $+ $calc(($ticks - %ppu.ticks) / 1000) seconds)
        echo $color(info2) -at 4 $+ $color(kick) Error: $+ $color(info2) Failed to retreive MSNRegcookies $iif(s isin %m2,& SubscriberInfo) for " $+ %p $+ " [Reason: $iif($bfind(&ppu,1-,Location: /KidsPassport.msnw),Passport is considered a Kid's Passport,$iif($bfind(&ppu,1-,Location: /mdunavail.msnw),MSN Nickname service is under maintenance (temporarily unavailable),Passport is not subscribed to MSN)) $+ ].
        sockclose %s | unset %ppu.* | return
      }
      elseif ($bfind(&ppu,1-,Location:)) {
        remini $+(",%dir,") %p cookie | remini $+(",%dir,") %p $ppu.sivar
        echo $color(info2) -at 3 Passport info (Cookies) for " $+ %p $+ " is now updated ( $+ $calc(($ticks - %ppu.ticks) / 1000) seconds)
        echo $color(info2) -at 4 $+ $color(kick) Error: $+ $color(info2) Failed to retreive MSNRegcookies $iif(s isin %m2,& SubscriberInfo) for " $+ %p $+ " [Reason: MSN wishes that you visit this link before attempting to update your passport/joining a room. Link : $gettok($bvar(&ppu,1-).text,2,32) ].
        sockclose %s | unset %ppu.* | return
      }
    }
    elseif (%t == subinfo) {
      if ($bfind(&ppu,1-,SubscriberInfo)) {
        tokenize 32 $wildtok($bvar(&ppu,1-).text,*SubscriberInfo*,1,60) | writeini $+(",%dir,") %p $ppu.sivar $gettok($1-,4,34) | if (%p == $msn.ini(selpp)) { %msnpp. [ $+ [ $ppu.sivar ] ] = $readini(%dir,%p,$ppu.sivar) }
        echo $color(info2) -at 3 Passport info (Cookies + SubscriberInfo) for " $+ %p $+ " is now updated ( $+ $calc(($ticks - %ppu.ticks) / 1000) seconds).
        sockclose %s | unset %ppu.* return
      }
      elseif ($bfind(&ppu,1-,Location: /KidsPassport.msnw)) || ($bfind(&ppu,1-,temp += '</OBJECT>';)) {
        remini $+(",%dir,") %p $ppu.sivar
        echo $color(info2) -at 3 Passport info (Cookies) for " $+ %p $+ " is now updated ( $+ $calc(($ticks - %ppu.ticks) / 1000) seconds)
        echo $color(info2) -at 4 $+ $color(kick) Error: $+ $color(info2) Failed to retreive SubscriberInfo for " $+ %p $+ " [Reason: $iif($bfind(&ppu,1-,Location: /KidsPassport.msnw),Passport is considered a Kid's Passport,$iif($bfind(&ppu,1-,Location: /mdunavail.msnw),MSN Nickname service is under maintenance (temporarily unavailable),Passport is not subscribed to MSN)) $+ ].
        sockclose %s | unset %ppu.* | return
      }
    }
    elseif (%t == userrole) {
      if ($bfind(&ppu,1-,>RenderChat)) { 
        writeini $+(",%dir,") %p UserRole $gettok($bvar(&ppu,1-).text,8,39) | if (%p == $msn.ini(selpp)) { %msnpp.UserRole = $readini(%dir,%p,UserRole) }
        echo $color(info2) -at 3 Passport info (Cookies + UserRole for group " $+ $gettok(%s,3,46) $+ ") for " $+ %p $+ " is now updated ( $+ $calc(($ticks - %ppu.ticks) / 1000) seconds).
        sockclose %s | unset %ppu.* | return 
      }
      elseif ($bfind(&ppu,1-,Error Message:)) {
        remini $+(",%dir,") %p UserRole | var %e = $gettok($bvar(&ppu,1-).text,3,32) , %msg = $iif(%e == user,no membership to group,$iif(%e == this,chatroom not created,$iif(%e isin could we,group not found,unknown)))
        echo $color(info2) -at 3 Passport info (Cookies) for " $+ %p $+ " is now updated ( $+ $calc(($ticks - %ppu.ticks) / 1000) seconds)
        echo $color(info2) -at 4 $+ $color(kick) Error: $+ $color(info2) Failed to retreive UserRole for group " $+ $gettok(%s,3,46) $+ " [Reason: %msg $+ ].
        sockclose %s | unset %ppu.* | return
      }
    }
  }
}
menu * {
  Vincula Passport Updater - by The Gate Keeper
  .Update Cookies Only : update
  .Update Cookies + SubscriberInfo : update -s
  .Update Cookies + UserRole : update -u
}